
#include "rabinpoly.h"

#define FINGERPRINT_PT  0xbfe6b8a5bf378d83LL

#define CHUNK_MASK	((1<<13) - 1)
#define CHUNK_MIN	(1024 * 2)
#define CHUNK_MAX	(1024 * 64)

extern "C" u_int64_t 
fingerprint(const unsigned char *data, size_t count)
{
  window w (FINGERPRINT_PT);
  w.reset();
  u_int64_t fp = 0;
  for (size_t i = 0; i < count; i++)
    fp = w.append8 (fp, data[i]);
  return fp;
}

extern "C" int
chunk(const unsigned char *data, size_t len, int minChunk, int maxChunk) 
{
    window w (FINGERPRINT_PT);
    w.reset();
    u_int64_t fp = 0;
    int i;
    int		size;

    size = 0;
    for (i = 0; i < len; i++) {
	size++;
	fp = w.slide8(data[i]);
	if (size < minChunk) {
	    continue;
	}
	if (size > maxChunk) {
	    break;
	}
	if ((fp & CHUNK_MASK) == 0) {
	    break;
	}
    }
    return size;
}


