
#include <iostream>
#include "rabinpoly.h"

#define FINGERPRINT_PT  0xbfe6b8a5bf378d83LL

#define CHUNK_MASK	((1<<13) - 1)
#define CHUNK_MIN	(1024 * 2)
#define CHUNK_MAX	(1024 * 64)
#define CHUNK_VALUE	0xfeedbabe

extern "C" u_int64_t 
fingerprint(const unsigned char *data, size_t count)
{
  window w (FINGERPRINT_PT);
  w.reset();
  u_int64_t fp = 0;
  for (size_t i = 0; i < count; i++)
    fp = w.slide8 (data[i]);
  return fp;
}

extern "C" int
chunk(const unsigned char *data, size_t len, int minChunk, int maxChunk) 
{
    window w (FINGERPRINT_PT);
    w.reset();
    u_int64_t fp = 0;
    int i;

    for (i = 0; i < len; i++) {
	fp = w.slide8(data[i]);
//	cout << "data = " << (unsigned int) data[i] << " fp = " << fp << "\n";
	if ((fp & CHUNK_MASK) == (CHUNK_VALUE & CHUNK_MASK)) {
//	    cout << "boundary at " <<  i << "\n";
	    if (i+1 < minChunk) {
		continue;
	    } else {
		break;
	    }
	}
	if (i+1 >= maxChunk) {
	    break;
	}
    }
    return i+1;
}


