#include <stdio.h>
#include <sys/ptrace.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

int
main(int argc, char **argv) {
    int		pid;
    int		status;
    int		rc;
    int		value;

    pid = fork();
    if (pid == 0) {
	rc = ptrace(PTRACE_TRACEME, 0, NULL, NULL);
	if (rc == -1) {
	    perror("PTRACE_TRACEME failed.\n");
	    exit(1);
	}
	rc = execl("./output", "./output", NULL);
	if (rc == -1) {
	    perror("execl failed.\n");
	    exit(1);
	}
    } else {
	pid = wait(&status);
	if(WIFSTOPPED(status)) {
	    printf("Child stopped by signal %d.\n", WSTOPSIG(status));
	} else if (WIFSIGNALED(status)) {
	    printf("Child killed by signal %d.\n", WTERMSIG(status));
	} else {
	    printf("Wait returned 0x%x\n", status);
	}
	errno = 0;
	value = ptrace(PTRACE_PEEKTEXT, pid, 0x8048390, NULL);
	if (errno) {
	    perror("PTRACE_PEEKTEXT failed\n");
	    exit(1);
	}
	printf("0x8048390 = 0x%x\n", value);
	rc = ptrace(PTRACE_CONT, pid, NULL, NULL);
	if (rc == -1) {
	    perror("PTRACE_CONT failed.\n");
	    exit(1);
	}
	pid = wait(&status);
	if(WIFSTOPPED(status)) {
	    printf("Child stopped by signal %d.\n", WSTOPSIG(status));
	} else if (WIFSIGNALED(status)) {
	    printf("Child killed by signal %d.\n", WTERMSIG(status));
	} else {
	    printf("Wait returned 0x%x\n", status);
	}
	errno = 0;
	value = ptrace(PTRACE_PEEKTEXT, pid, 0x8048390, NULL);
	if (errno) {
	    perror("PTRACE_PEEKTEXT failed\n");
	    exit(1);
	}
	printf("0x8048390 = 0x%x\n", value);
	rc = ptrace(PTRACE_KILL, pid, NULL, NULL);
	if (rc == -1) {
	    perror("PTRACE_KILL failed.\n");
	    exit(1);
	}
    }
    exit(0);
}

