#ifndef _SLINK_H
#define _SLINK_H

#include <elf.h>
#include <elflib.h>
#include <status.h>
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif
#ifdef HAVE_SYS_MMAN_H
#include <sys/mman.h>
#endif


#define assume(expr) \
    if (!(expr)) { \
    fprintf(stderr, "Assumption %s at %s:%d is false\n", __STRING(expr), \
    __FILE__, __LINE__); abort(); }

#ifdef HAVE_LIBPUB
#include <publib.h>
#else
#define xmalloc(s) malloc(s)
#define xfree(p) free(p)
#endif

#define PAGE_SIZE 0x1000
#define PAGE_MASK (PAGE_SIZE - 1)
#define PAGE_OFFSET(value) ((value) & PAGE_MASK)

typedef int Boolean;
#define TRUE 1
#define FALSE 0
#endif
