/*
 * List_Destroy.c --
 *
 *      Source code for the List_Destroy library procedure.
 *
 * @COPYRIGHT@
 */

static char rcsid[] __attribute__ ((unused)) =
"$Id: List_Destroy.c,v 1.1 2004/01/16 20:00:07 jhh Exp $";

#include "list.h"

/*
 * List_Destroy --
 *
 *      Destroy a list given a pointer to its header and a deallocation
 *      procedure.
 *
 * Results:
 *      None.
 *
 * Side effects:
 *      The list is destroyed.
 */

void
List_Destroy (headerPtr, deallocator)
    List_Links *headerPtr;
    List_ElementDeallocator deallocator;
{
    List_Links 	*itemPtr;
    List_Links	*nextPtr;

    LIST_FORALL_DEL(headerPtr, itemPtr, nextPtr) {
        List_Remove (itemPtr);
	if (deallocator == NULL) {
	    FREE((void *) itemPtr);
	} else {
	    (*deallocator) (itemPtr);
	}
    }
}
