/* 
 * List_KeyedInit.c --
 *
 *	Source code for the List_KeyedInit library procedure.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

#ifndef lint
static char rcsid[] __attribute__ ((unused)) =
"$Header: /cvs/cvs/slinky/slinky/src2/libs/list/List_KeyedInit.c,v 1.1 2004/01/16 20:00:07 jhh Exp $ SPRITE (Berkeley)";
#endif not lint

#include "list.h"

/*
 * ----------------------------------------------------------------------------
 *
 * List_KeyedInit --
 *
 *	Initialize a header pointer to point to an empty list.  The List_Links
 *	structure must already be allocated.
 *
 * Results:
 *	None.
 *
 * Side effects:
 *	The header's pointers are modified to point to itself.
 *
 * ----------------------------------------------------------------------------
 */
void
List_KeyedInit(headerPtr, keyType)
    register List_KeyedLinks *headerPtr;  /* Pointer to header */
    List_KeyType	keyType;	/* Type of keys the list uses. */
{
    if (headerPtr == (List_KeyedLinks *) LIST_NIL || !headerPtr) {
	panic("List_Init: invalid header pointer.\n");
    }
    List_Init(&headerPtr->links);
    headerPtr->key = NULL;
    headerPtr->type = keyType;
}
